MODULE BtDTraps;
IMPORT SYSTEM, Kernel32, Objects, Modules, Machine, Heaps, Traps, Reflection, Streams, KernelLog;
CONST
	Trace = FALSE;
TYPE
	BrkPnt* = POINTER TO RECORD
		c*:CHAR; (*save char here*)
		adr*:LONGINT;
		pos*:LONGINT;
		active*:BOOLEAN;
		next*:BrkPnt;
	END;
	DebugHandler* = PROCEDURE {DELEGATE} ( VAR int: Kernel32.Context;  VAR exc: Kernel32.ExceptionRecord;  VAR handled: BOOLEAN );

	
	TestRec* = RECORD
		tint*:LONGINT;
		treal*:REAL;
		tarr1*:ARRAY 10 OF LONGINT;
		tarr2:ARRAY 10,10 OF REAL;
		tarr3*:ARRAY 80 OF CHAR;
	END;
	TestRec2* = RECORD(TestRec)
		tint12*:LONGINT;
		treal2*:REAL;
		tarr12*:ARRAY 10 OF LONGINT;
		tarr22:ARRAY 10,10 OF REAL;
		tarr32*:ARRAY 80 OF CHAR;
	END;
	TestRec3* = RECORD
		tint13*:LONGINT;
		treal3*:REAL;
		tarr13*:ARRAY 10 OF LONGINT;
		tarr23:ARRAY 10,10 OF REAL;
		tarr33*:ARRAY 80 OF CHAR;
	END;
	TestArrP = ARRAY 23 OF POINTER TO RECORD(TestRec2)
		zz1:LONGINT;
		zz2:ARRAY 13 OF CHAR;
	END;
VAR
	brkPnt*:BPList;
	testRecL1:BrkPnt;
	testRecL:TestRec;
	testRecL2:TestRec2;
	exceptionhandler: Objects.ExceptionHandler; (*Save system handler here*)
	debughandler:DebugHandler;
TYPE

	BPList* = OBJECT
	VAR
		list*,
		tmp*:BrkPnt;
		active:BOOLEAN;
		PROCEDURE &Init*(*CONST textView : WMTextView.TextView*);
		BEGIN
(*?
Stupid
  *)
(*  			KernelLog.String("brkPnt = active"); KernelLog.Ln; *)
			active:=TRUE; 
		END Init;

		PROCEDURE AddBP*(adr:ADDRESS);
		VAR
			p,next,last:BrkPnt;
		BEGIN
			next:=list;

			NEW(p);
			p.adr:=adr;
			IF next#NIL THEN
				WHILE (next#NIL)&(next.adr<adr) DO last:=next; next:=next.next END;
				IF next=NIL THEN
					last.next:=p;
				ELSE
					IF next.adr=adr THEN RETURN END;
					p.adr:=next.adr;next.adr:=adr;
					IF Trace THEN KernelLog.String("SetBrk="); KernelLog.Hex(adr,0);  KernelLog.Ln; END;
					SetBrk(next);
					p.next:=next.next;
					next.next:=p;
				END;
			ELSE
				list:=p;
				IF Trace THEN KernelLog.String("SetBrk="); KernelLog.Hex(adr,0);  KernelLog.Ln; END;
				SetBrk(p);
			END;
			IF Trace THEN
				DumpList(list);
			END;
		END AddBP;

		PROCEDURE FindBP(lst:BrkPnt;adr:ADDRESS):BOOLEAN;
		VAR
			next:BrkPnt;
		BEGIN
			next:=lst;
			WHILE (next#NIL)&(next.adr#adr) DO next:=next.next END;
			RETURN next#NIL;
		END FindBP;
		
		PROCEDURE AddTmpBP*(adr:ADDRESS);
		VAR
			p:BrkPnt;
			cmd:ARRAY 20 OF CHAR;
		BEGIN
			IF FindBP(list,adr)OR FindBP(tmp,adr) THEN RETURN END; (*no add if now real BP*)
			NEW(p);
			p.adr:=adr;
			p.next:=tmp;tmp:=p;
			SetBrk(p);
		END AddTmpBP;

		PROCEDURE RemoveTmpBP*;
		VAR
			p:BrkPnt;
		BEGIN
			WHILE tmp#NIL DO
				ClrBrk(tmp);
				tmp:=tmp.next;
			END;
			tmp:=NIL;
		END RemoveTmpBP;

 
		PROCEDURE RemoveBP*(adr:ADDRESS);
		VAR
			p,next,last:BrkPnt;
		BEGIN
			next:=list;
			WHILE (next#NIL)&(next.adr#adr) DO last:=next; next:=next.next END;
			IF next=NIL THEN RETURN END;
			ClrBrk(next);
			IF next=list THEN list:=next.next;
			ELSE
				IF next.next=NIL THEN
					last.next:=NIL;
				ELSE
					next.adr:=next.next.adr;
					next.next:=next.next.next;
				END;
			END;
			IF Trace THEN
				DumpList(list);
			END;
		END RemoveBP;


		PROCEDURE DumpList*(lst:BrkPnt);
		BEGIN
			KernelLog.String("dh: ");
			WHILE lst#NIL DO
				 KernelLog.Hex(lst.adr, 8); KernelLog.String(", ");
				 lst:=lst.next;
			END;
			KernelLog.Ln;
		END DumpList;
		
		PROCEDURE SetBrk*(bp:BrkPnt);
		BEGIN
			IF active THEN
(*				KernelLog.String("active"); KernelLog.Ln; *)
				SYSTEM.GET(bp.adr, bp.c);
				SYSTEM.PUT(bp.adr, 0CCX);
			END
		END SetBrk;

		PROCEDURE ClrBrk*(bp:BrkPnt);
		BEGIN
(*				KernelLog.String("clear "); KernelLog.Ln; *)
				SYSTEM.PUT(bp.adr, bp.c);
		END ClrBrk;
		
		PROCEDURE ChgState*(state:BOOLEAN);
		VAR
			p:BrkPnt;
		BEGIN
			IF active=state THEN RETURN END;
(*			KernelLog.String("ChgState "); KernelLog.Ln; *)

			active:=state;
			p:=list;
			WHILE p#NIL DO
				IF active THEN
					SetBrk(p);
				ELSE
					ClrBrk(p);
				END;
				p:=p.next;
			END;
			p:=tmp;
			WHILE p#NIL DO
				IF active THEN
					SetBrk(p);
				ELSE
					ClrBrk(p);
				END;
				p:=p.next;
			END;
			IF Trace THEN 
			KernelLog.String("list:");KernelLog.Ln;
			DumpList(list);
			KernelLog.String("tmp:");KernelLog.Ln;
			DumpList(tmp);
			KernelLog.String("...ok!"); KernelLog.Ln; 
			END;
		END ChgState;

	END BPList;
 




PROCEDURE FindEIPByModulePC*(CONST modn:ARRAY OF CHAR;PC:LONGINT):LONGINT;
VAR
	m : Modules.Module; 
BEGIN
	m := Modules.root;
	WHILE (m # NIL) & (m.name # modn) DO m := m.next END;
	IF m # NIL THEN
	   RETURN PC+SYSTEM.ADR(m.code[0]);
        ELSE
          RETURN -1;
        END;
END FindEIPByModulePC;

PROCEDURE TestTrap*;
VAR
	LocVar:LONGINT;
	m, i, j, ofs, t, res : LONGINT;
BEGIN
	LocVar:=45H;
	CODE	INT 3	END;
END TestTrap;

	(* Write the specified procedure name and returns parameters for use with NextVar and Variables. *)
	PROCEDURE WriteProc0*( mod: Modules.Module; pc, fp: ADDRESS; VAR refs: Modules.Bytes;
			VAR refpos: LONGINT; VAR base: ADDRESS);
	VAR ch: CHAR; startpc: ADDRESS;
	BEGIN
		refpos := -1;
		IF mod = NIL THEN
			IF pc = 0 THEN KernelLog.String("NIL")
			ELSE
				KernelLog.String("Unknown PC="); KernelLog.Address(pc); KernelLog.Char("H")
			END;
			IF fp # -1 THEN
				KernelLog.String(" FP="); KernelLog.Address(fp); KernelLog.Char("H")
			END
		ELSE
			KernelLog.String(mod.name);
			IF ~NewObjectFile(mod.refs) THEN
				DEC(pc, ADDRESSOF(mod.code[0]));
			END;
			refs := mod.refs;
			IF (refs # NIL) & (LEN(refs) # 0) THEN
				refpos := FindProc(refs, pc, startpc);
				IF refpos # -1 THEN
					KernelLog.Char(".");
					ch := refs[refpos]; INC(refpos);
					IF ch = "$" THEN base := mod.sb ELSE base := fp END;	(* for variables *)
					WHILE ch # 0X DO KernelLog.Char(ch); ch := refs[refpos]; INC(refpos) END;
					KernelLog.Char(":"); KernelLog.Int(LONGINT(pc-startpc),1);
				END
			END;
			KernelLog.String(" pc="); KernelLog.Int(LONGINT(pc),1); KernelLog.String(" ["); KernelLog.Address (pc); KernelLog.String("H]");
			KernelLog.String(" = "); KernelLog.Int(LONGINT(startpc),1);  KernelLog.String(" + "); KernelLog.Int(LONGINT(pc-startpc),1);
			KernelLog.String(" crc="); KernelLog.Hex(mod.crc,-8);
		END
	END WriteProc0;

PROCEDURE TestTrapEx*;
VAR
	LocVar:LONGINT;
	m, i, j, ofs, t, res : LONGINT;
	pc,bp:ADDRESS;
	VAR refs: Modules.Bytes; refpos: LONGINT; base: ADDRESS;

BEGIN
	LocVar:=45H;
	CODE
		CALL	ty
		ty:
		POP EAX
		MOV	[EBP+pc],EAX
		MOV	EAX,EBP
		MOV	[EBP+bp],EAX
	END;
	WriteProc0(Modules.ModuleByName('BtDTraps') , pc, bp, refs, refpos, base);KernelLog.Ln;
	IF refpos # -1 THEN Variables(refs, refpos, base) END;

	CODE	INT 3	END;
END TestTrapEx;

PROCEDURE TestTrapEx3*;
VAR
	maffffffffffffffffffffff, d111i,f11323j, refdffs22 : LONGINT;
BEGIN
	TestTrapEx
END TestTrapEx3;

PROCEDURE TestTrapEx2*;
VAR
	ma, di,fj, res22 : LONGINT;
BEGIN
	TestTrapEx3
END TestTrapEx2;

(**Retrieve a procedure address given a module name, the procedure name *)
(* This hack for make hook and restore ExceptionHandler*)
PROCEDURE GetProcedure*(CONST moduleName, procedureName : ARRAY OF CHAR; VAR entryAdr : ADDRESS);
VAR 
	mod : Modules.Module; ignoreMsg : ARRAY 32 OF CHAR; 
	m, i, j, ofs, t, res : LONGINT;
	ch:CHAR;
	n: ARRAY 64 OF CHAR;
	(* Get a compressed refblk number. *)
	PROCEDURE GetNum( refs: Modules.Bytes;  VAR i, num: LONGINT );  
	VAR n, s: LONGINT;  x: CHAR;  
	BEGIN 
		s := 0;  n := 0;  x := refs[i];  INC( i );  
		WHILE ORD( x ) >= 128 DO INC( n, ASH( ORD( x ) - 128, s ) );  INC( s, 7 );  x := refs[i];  INC( i ) END;  
		num := n + ASH( ORD( x ) MOD 64 - ORD( x ) DIV 64 * 64, s )
	END GetNum; 
BEGIN
	entryAdr:=0;
	mod := Modules.ThisModule(moduleName, res, ignoreMsg);
	IF res=0 THEN
		i := 0; m := LEN(mod.refs^);
		ch := mod.refs[i]; INC(i);
		WHILE (i < m) & ((ch = 0F8X) OR (ch = 0F9X)) DO	(* proc *)
			GetNum(mod.refs, i, ofs);	(* pofs *)
			IF ch = 0F9X THEN
				GetNum(mod.refs, i, t);	(* nofPars *)
				INC(i, 3)	(* RetType, procLev, slFlag *)
			END;
			j:=0;
			REPEAT
				n[j]:= mod.refs[i];
				INC(i);INC(j);
			UNTIL n[j-1]=0X;
			IF n=procedureName THEN 
				entryAdr:=ofs+mod.firstProc;
				ch:=0X;
			ELSE
				IF i < m THEN
					ch := mod.refs[i]; INC(i);	(* 1X | 3X | 0F8X | 0F9X *)
					WHILE (i < m) & (ch >= 1X) & (ch <= 3X) DO	(* var *)
						ch := mod.refs[i]; INC(i);	(* type *)
						IF (ch >= 81X) OR (ch = 16X) OR (ch = 1DX) THEN
							GetNum(mod.refs, i, t)	(* dim/tdadr *)
						END;
						GetNum(mod.refs, i, t);	(* vofs *)
						REPEAT ch := mod.refs[i]; INC(i) UNTIL ch = 0X;	(* vname *)
						IF i < m THEN ch := mod.refs[i]; INC(i) END	(* 1X | 3X | 0F8X | 0F9X *)
					END
				END
			END;
		END;
	END;
END GetProcedure;


		PROCEDURE GetVarVal(v: Reflection.Variable; VAR s:ARRAY OF CHAR);
		VAR
			st : Streams.StringWriter;
			col:LONGINT;
		BEGIN
			NEW(st, 100); Reflection.WriteVar(st,v,col);st.Get(s);
		END GetVarVal;
		
		
	PROCEDURE WriteSimpleVar( adr, type, tdadr: ADDRESS;  VAR col: LONGINT );
	VAR ch: CHAR;  sval: SHORTINT;  ival: INTEGER;  lval: LONGINT;  rval: REAL; xval: LONGREAL; hval : HUGEINT;
		address: ADDRESS; pos0: LONGINT;
	BEGIN
(*		pos0 := w.Pos();*)
		CASE type OF
		1, 3:  (* BYTE, CHAR *)
				SYSTEM.GET( adr, ch );
				IF (ch > " ") & (ch <= "~") THEN KernelLog.Char( ch ); ELSE KernelLog.Hex( ORD( ch ), -2 );  KernelLog.Char( "X" ) END;
		| 2:    (* BOOLEAN *)
				SYSTEM.GET( adr, ch );
				IF ch = 0X THEN KernelLog.String( "FALSE" )
				ELSIF ch = 1X THEN KernelLog.String( "TRUE" )
				ELSE KernelLog.Int( ORD( ch ), 1 );
				END;
		| 4:    (* SHORTINT *)
				SYSTEM.GET( adr, sval );
				KernelLog.Int( sval, 1 );
				IF sval > 0H THEN KernelLog.String(" ("); KernelLog.Hex(sval, -2); KernelLog.String("H)") END;
		| 5:    (* INTEGER *)
				SYSTEM.GET( adr, ival );
				KernelLog.Int( ival, 1 );
				IF ival > 0H THEN KernelLog.String(" (");KernelLog.Hex(ival,-4);KernelLog.Char("H");KernelLog.String(")"); END;
		| 6:    (* LONGINT *)
				SYSTEM.GET( adr, lval );
				KernelLog.Int( lval, 1 );
				IF lval > 0H THEN KernelLog.String( " (" );  KernelLog.Hex( lval,-8 );  KernelLog.String( "H)" );  END;
		| 7:     (* REAL *)
				SYSTEM.GET(adr,rval); SYSTEM.GET(adr,lval);
				(*KernelLog.Float(rval,15);*)
				IF lval > 0H THEN KernelLog.String(" ("); KernelLog.Hex(lval,-8);KernelLog.Char( "H" ); KernelLog.String(")"); END;
		| 8:      (* LONGREAL *)
				SYSTEM.GET(adr,xval);SYSTEM.GET(adr,hval);
				(*KernelLog.Float(xval,15);*)
				IF hval > 0H THEN  KernelLog.String( " (" );  KernelLog.Hex(hval,-16);  KernelLog.String( "H)" );  END;
		| 13,29: (* POINTER *)
				SYSTEM.GET( adr, address ); KernelLog.Address( address );  KernelLog.String( "H" );
				(* output type information, if available: *)
				KernelLog.String(" (TODO");
				(* do a check if the address is in the heap range *)
(*				IF CheckHeapAddress(address) THEN
					SYSTEM.GET(address + Heaps.TypeDescOffset, address);
					WriteType(w,address);
				ELSE KernelLog.String("NIL");
				END;*)
				KernelLog.String(")");
		| 16:   (* HUGEINT *)
				SYSTEM.GET( adr , hval );
				KernelLog.Hex(hval,1);
				IF hval < 0 THEN KernelLog.String( "H (" ); KernelLog.Hex(hval,-16); KernelLog.String(")") END;
		| 9:    (* SET *)
				SYSTEM.GET( adr, lval );
(*				KernelLog.Set( SYSTEM.VAL( SET, lval ) );*)
		| 22:  (* RECORD *)
				KernelLog.String( "Rec@" );  KernelLog.Hex( tdadr, -8 );  KernelLog.Char( "H" );
		| 14:  (* PROC *)
(*				SYSTEM.GET( adr, lval );  WriteProc( w, lval );*)
		END;
	END WriteSimpleVar;

	(** Write a variable value.  The v parameter is a variable descriptor obtained with NextVar.  Parameter col is incremented with the (approximate) number of characters written. *)
	PROCEDURE GetLocalVarVal*(v: Reflection.Variable);
	VAR ch: CHAR;
		adr:ADDRESS;n:LONGINT;
		
		val:ARRAY 100 OF CHAR;
		st : Streams.StringWriter;
		col:LONGINT;
	BEGIN
		adr:=v.adr;n:=v.n;
		IF v.type = 15 THEN
			LOOP
				IF (n = 0) THEN EXIT END;
				SYSTEM.GET(adr, ch);
				INC(adr);
				IF (ch < " ") OR (ch > "~") THEN EXIT END;
				KernelLog.Char(ch); DEC(n)
			END;
			KernelLog.Char(22X); 
			IF ch # 0X THEN KernelLog.Char("!") END
		ELSE
			WHILE n > 0 DO
(*				KernelLog.String("WriteSimpleVar ");*)
				WriteSimpleVar(adr, v.type, v.tdadr, col);
				DEC(n); INC(adr, v.size);
				IF n > 0 THEN
					KernelLog.String(", "); 
				END
			END
		END
	END GetLocalVarVal;

	(* Get a compressed refblk number. *)
	PROCEDURE GetNum( refs: Modules.Bytes;  VAR i, num: LONGINT );  
	VAR n, s: LONGINT;  x: CHAR;  
	BEGIN 
		s := 0;  n := 0;  x := refs[i];  INC( i );  
		WHILE ORD( x ) >= 128 DO INC( n, ASH( ORD( x ) - 128, s ) );  INC( s, 7 );  x := refs[i];  INC( i ) END;  
		num := n + ASH( ORD( x ) MOD 64 - ORD( x ) DIV 64 * 64, s )
	END GetNum; 

	PROCEDURE NewObjectFile*(refs: Modules.Bytes): BOOLEAN;
	BEGIN
		RETURN (refs # NIL) & (LEN(refs) >0) & (refs[0]=0FFX);
	END NewObjectFile;

	(* Find a procedure in the reference block.  Return index of name, or -1 if not found. *)
	PROCEDURE FindProc*(refs: Modules.Bytes; modpc: ADDRESS; VAR startpc: ADDRESS): LONGINT;
	VAR pos, len, t, tstart, tend, proc: LONGINT; ch: CHAR; newObjectFile, found: BOOLEAN;
	BEGIN
		IF (refs=NIL) OR (LEN(refs) = 0) THEN RETURN -1 END;
		newObjectFile := NewObjectFile(refs);
		proc := -1; pos := 0; len := LEN(refs^);
		IF newObjectFile THEN INC(pos) END;
		ch := refs[pos]; INC(pos); tstart := 0;
		found := FALSE;
		WHILE ~found & (pos < len) & ((ch = 0F8X) OR (ch = 0F9X)) DO	(* proc *)
			GetNum(refs, pos, tstart);	(* procedure offset *)
			IF newObjectFile THEN
				GetNum(refs,pos,tend);
				found := (tstart <=modpc) & (tend  > modpc)
			ELSE
				found := tstart > modpc
			END;
				IF ch = 0F9X THEN
					GetNum(refs, pos, t);	(* nofPars *)
					INC(pos, 3)	(* RetType, procLev, slFlag *);
					IF newObjectFile THEN INC(pos,6) END;
				END;
			IF ~found THEN (* not yet found -- remember startpc and position for next iteration *)
				startpc := tstart;
				proc := pos;	(* remember this position, just before the name *)
				REPEAT ch := refs[pos]; INC(pos) UNTIL ch = 0X;	(* pname *)
				IF pos < len THEN
					ch := refs[pos]; INC(pos);	(* 1X | 3X | 0F8X | 0F9X *)
					WHILE (pos < len) & (ch >= 1X) & (ch <= 3X) DO	(* var *)
						ch := refs[pos]; INC(pos);	(* type *)
						IF (ch >= 81X) OR (ch = 16X) OR (ch = 1DX) THEN
							GetNum(refs, pos, t)	(* dim/tdadr *)
						END;
						GetNum(refs, pos, t);	(* vofs *)
						REPEAT ch := refs[pos]; INC(pos) UNTIL ch = 0X;	(* vname *)
						IF pos < len THEN ch := refs[pos]; INC(pos) END	(* 1X | 3X | 0F8X | 0F9X *)
					END
				END
			END;
		END;
		IF newObjectFile THEN
			IF found THEN
				startpc := tstart; proc := pos;
			ELSE proc := -1
			END;
		END;
		RETURN proc
	END FindProc;

	(* Debbuger exception handler. *)
	PROCEDURE Exception( VAR int: Kernel32.Context;  VAR exc: Kernel32.ExceptionRecord;  VAR handled: BOOLEAN );
	BEGIN  (* interrupts off *)
		handled := FALSE;
		IF Trace THEN KernelLog.String("Debug exception handler! "); KernelLog.Ln; END;
		IF debughandler#NIL THEN
			debughandler(int,exc,handled);
			IF Trace THEN KernelLog.String("user complit! "); KernelLog.Ln; END;
		END;
(*		IF 8 IN int.ContextFlags THEN
			EXCL(int.ContextFlags,8);
		ELSE
			INCL(int.ContextFlags,8);
		END;
*)
		IF (~handled)&(exceptionhandler#NIL) THEN
			IF Trace THEN KernelLog.String("do system! "); KernelLog.Ln; END;
			exceptionhandler(int,exc,handled);
		END;
	FINALLY
		(* if trap occurs in this procedure, then go on working right here *)
(*		KernelLog.String("Houston, we have a problem!"); KernelLog.Ln; *)
	END Exception;

PROCEDURE Install*;
VAR
	adr,adr1:ADDRESS;

BEGIN
	GetProcedure('Traps', 'Exception',adr);
	exceptionhandler:=SYSTEM.VAL(Objects.ExceptionHandler,adr);
	Objects.InstallExceptionHandler( Exception );
END Install;

(** *)
PROCEDURE InstallDbgHandler*(hndlr:DebugHandler);
BEGIN
	debughandler:=hndlr;
	Install();
END InstallDbgHandler;

PROCEDURE RemoveDbgHandler*();
BEGIN
	debughandler:=NIL;
END RemoveDbgHandler;

PROCEDURE GetGlobalVar*;
VAR
	m:Modules.Module;
	v:Reflection.Variable;
	i:LONGINT;
BEGIN
	KernelLog.String("==TestGetVar= ");  KernelLog.Ln; 
	m:=Modules.ModuleByName('BtDTraps');
	IF m#NIL THEN
		IF Reflection.FindVar(m,"testRecL",v) THEN
			KernelLog.String("Type= "); KernelLog.Int(v.type, 0); KernelLog.Ln; 
			KernelLog.String("adr= "); KernelLog.Int(v.adr, 0); KernelLog.Ln; 
			KernelLog.String("tdadr= "); KernelLog.Int(v.tdadr, 0); KernelLog.Ln; 
			KernelLog.String("size= "); KernelLog.Int(v.size, 0); KernelLog.Ln; 
			KernelLog.String("n= "); KernelLog.Int(v.n, 0); KernelLog.Ln; 
		ELSE
			KernelLog.String("variable not found!!!");  KernelLog.Ln; 
		END;
		IF Reflection.FindVar(m,"testRecL2",v) THEN
			KernelLog.String("Type= "); KernelLog.Int(v.type, 0); KernelLog.Ln; 
			KernelLog.String("adr= "); KernelLog.Int(v.adr, 0); KernelLog.Ln; 
			KernelLog.String("tdadr= "); KernelLog.Int(v.tdadr, 0); KernelLog.Ln; 
			KernelLog.String("size= "); KernelLog.Int(v.size, 0); KernelLog.Ln; 
			KernelLog.String("n= "); KernelLog.Int(v.n, 0); KernelLog.Ln; 
		ELSE
			KernelLog.String("variable not found!!!");  KernelLog.Ln; 
		END;
		IF Reflection.FindVar(m,"testRecL1",v) THEN
			KernelLog.String("Type= "); KernelLog.Int(v.type, 0); KernelLog.Ln; 
			KernelLog.String("adr= "); KernelLog.Int(v.adr, 0); KernelLog.Ln; 
			KernelLog.String("tdadr= "); KernelLog.Int(v.tdadr, 0); KernelLog.Ln; 
			KernelLog.String("size= "); KernelLog.Int(v.size, 0); KernelLog.Ln; 
			KernelLog.String("n= "); KernelLog.Int(v.n, 0); KernelLog.Ln; 
		ELSE
			KernelLog.String("variable not found!!!");  KernelLog.Ln; 
		END;

		IF Reflection.FindVar(m,"brkPnt",v) THEN
			KernelLog.String("Type= "); KernelLog.Int(v.type, 0); KernelLog.Ln; 
			KernelLog.String("adr= "); KernelLog.Int(v.adr, 0); KernelLog.Ln; 
			KernelLog.String("tdadr= "); KernelLog.Int(v.tdadr, 0); KernelLog.Ln; 
			KernelLog.String("size= "); KernelLog.Int(v.size, 0); KernelLog.Ln; 
			KernelLog.String("n= "); KernelLog.Int(v.n, 0); KernelLog.Ln; 
		ELSE
			KernelLog.String("variable not found!!!");  KernelLog.Ln; 
		END;
		FOR i:=0 TO LEN(m.typeInfo)-1 DO
			KernelLog.String("**************************************************************************");  KernelLog.Ln; 
			KernelLog.Memory(m.typeInfo[i],64);
			KernelLog.Ln;
			KernelLog.Memory(m.typeInfo[i].tag,64);
			
		END;
		HALT(33H);
	ELSE
		KernelLog.String("Module not found!!!");  KernelLog.Ln; 
	END;
END GetGlobalVar;

	(** Find global variables of mod (which may be NIL) and return it in the refs, refpos and base parameters for use by NextVar.  If not found, refpos returns -1. *)
	PROCEDURE InitVar*(mod: Modules.Module; VAR refs: Modules.Bytes; VAR refpos: LONGINT; VAR base: ADDRESS);
	VAR ch: CHAR; startpc: ADDRESS;
	BEGIN
		refpos := -1;
		IF mod # NIL THEN
			refs := mod.refs; base := mod.sb;
			IF (refs # NIL) & (LEN(refs) # 0) THEN
				refpos := FindProc(refs, 0, startpc);
				IF refpos # -1 THEN
					ch := refs[refpos]; INC(refpos);
					WHILE ch # 0X DO ch := refs[refpos]; INC(refpos) END
				END
			END
		END
	END InitVar;

PROCEDURE GetGlobalVars*;
VAR
	m:Modules.Module;
	v:Reflection.Variable;
	VAR refpos: LONGINT; base: ADDRESS; refs: Modules.Bytes;
BEGIN
	KernelLog.String("==Test GetGlobalVars= ");  KernelLog.Ln; 
	m:=Modules.ModuleByName('BtDTraps');
	IF m#NIL THEN
		InitVar(m, refs, refpos, base);
		IF refpos # -1 THEN
			KernelLog.String("State "); KernelLog.String(m.name); KernelLog.Char(":"); KernelLog.Ln;
			Variables(refs, refpos, base)
		END
	ELSE
		KernelLog.String("Module not found!!!");  KernelLog.Ln; 
	END;
END GetGlobalVars;

	(* Display variables. *)
	PROCEDURE Variables( refs: Modules.Bytes; refpos: LONGINT; base: ADDRESS);
	VAR v: Reflection.Variable; j, col: LONGINT; name: ARRAY 64 OF CHAR; etc: BOOLEAN;
	val: ARRAY 256 OF CHAR;
	CONST dense = FALSE;
	BEGIN
		LOOP
			Reflection.NextVar(refs, refpos, base, name, v);
			IF name[0] = 0X THEN EXIT END;
			(* write name *)
			IF (col # 0 ) & (v.n > 1) & (v.type # 15) THEN	(* Ln before array (except string) *)
				KernelLog.Ln; col := 0; 
			END;
			KernelLog.String("_"); KernelLog.String(name); KernelLog.Char("=");
			j := 0; WHILE name[j] # 0X DO INC(j) END;
			INC(col, 1+1+j);
				(* write variable *)
			IF (v.adr >= -4) & (v.adr < 4096) THEN	(* must be NIL VAR parameter *)
				KernelLog.String("NIL ("); KernelLog.Hex(v.adr, -8);
				KernelLog.Char(")"); INC(col, 14)
			ELSE
				etc := FALSE;
(*				IF v.type = 15 THEN
					IF v.n > 255 THEN etc := TRUE; v.n := 255 END
				ELSE
					IF v.n > 255 THEN etc := TRUE; v.n := 255 END
				END;*)
(*				KernelLog.String("TODO= ");KernelLog.Int(v.adr,0); KernelLog.Ln;  (*!WriteVar(w, v, col);	(* write value *) *)*)
				GetLocalVarVal(v);(*!Test and remove*)

				IF etc THEN KernelLog.String("..."); INC(col, 3) END;
				IF ~dense THEN
					KernelLog.Ln; col := 0; 
				END;
			END;
			IF col > 255 THEN KernelLog.Ln; col := 0;  END
		END;
		IF col # 0 THEN KernelLog.Ln;END
	END Variables;

PROCEDURE GetLocalVars*;
	VAR t: Objects.Process;  user, traceTrap: BOOLEAN;   exchalt: LONGINT;
		mod:Modules.Module;
		refs: Modules.Bytes; refpos: LONGINT; base: ADDRESS; name,val: ARRAY 256 OF CHAR;
		v: Reflection.Variable;
		ch:CHAR;
		adr,startpc:ADDRESS;
BEGIN
		KernelLog.String("GetLocalVars ("); 
		(*!Tmp Hack *)	GetProcedure('BtDTraps', 'GetLocalVars',adr);
		KernelLog.Hex(adr,8);KernelLog.String("H)"); KernelLog.Ln;
		mod :=Modules.ModuleByName('BtDTraps'); (*!TODO:  Modules.ThisModuleByAdr(int.PC);*)
		IF mod#NIL THEN
			(*Getting global module variables*)
			Reflection.InitVar(mod, refs, refpos, base);
			IF refpos # -1 THEN
				Reflection.NextVar(refs, refpos, base, name, v);
				WHILE name#"" DO 
					GetVarVal(v,val);
					KernelLog.String(name);KernelLog.String("== ");KernelLog.String(val); KernelLog.Ln;
					Reflection.NextVar(refs, refpos, base, name, v);
				END;
			END;

			IF ~NewObjectFile(mod.refs) THEN
				DEC(adr, ADDRESSOF(mod.code[0]));
			END;
			(*Local var*)
			refpos := -1; refs := mod.refs;

			IF (refs # NIL) & (LEN(refs) # 0) THEN
				refpos := FindProc(refs, adr, startpc);
				IF refpos # -1 THEN
					KernelLog.Char(".");
					ch := refs[refpos]; INC(refpos);
					IF ch = "$" THEN base := mod.sb ELSE 
					CODE
						MOV EAX,EBP
						MOV [EBP+base], EAX
					END;
					(*base := fp*)KernelLog.String("PTH"); END;	(* for variables *)
					WHILE ch # 0X DO KernelLog.Char(ch); ch := refs[refpos]; INC(refpos) END;
					KernelLog.Char(":"); KernelLog.Int(LONGINT(adr-startpc),1);
					KernelLog.String(name);
					IF refpos # -1 THEN Variables( refs, refpos, base)  ELSE  KernelLog.String("refpos = -1"); END;
				END
			END;
			
		END;

END GetLocalVars;

PROCEDURE TestProcObj*;
VAR
	adr:ADDRESS;
BEGIN
(*	WMTextView2.TextView.RenderAboveTextMarkers*)
	GetProcedure('BtDTraps', 'SetBrk',adr);
	KernelLog.String("Adr "); KernelLog.Hex(adr, 0); KernelLog.Ln;
	GetProcedure('BtDTraps', '$$',adr);
	KernelLog.String("Adr "); KernelLog.Hex(adr, 0); KernelLog.Ln;
	GetProcedure('BtDTraps', 'Cleanup',adr);
	KernelLog.String("Adr "); KernelLog.Hex(adr, 0); KernelLog.Ln;
END TestProcObj;


(** Termination handler. Removes the window from the display space when the module is unloaded. *)
PROCEDURE Cleanup;	(* K *)
BEGIN
		IF exceptionhandler#NIL THEN
			Objects.InstallExceptionHandler( exceptionhandler );
			KernelLog.String( "Traps: TrapHandler Restored!" );  KernelLog.Ln;
		ELSE
			KernelLog.String( "Not need to restore traps handler !" );  KernelLog.Ln;
		END;
END Cleanup;

BEGIN
	testRecL.tint:=13H;
	testRecL.treal:=0.5;
	Modules.InstallTermHandler(Cleanup);
	NEW(brkPnt);

END BtDTraps.


BtDTraps.TestTrap~

BtDTraps.TestTrapEx2~

BtDTraps.GetGlobalVar~

BtDTraps.GetGlobalVars~

BtDTraps.GetLocalVars~
BtDTraps.Install~


BtDTraps.TestProcObj~

SystemTools.Free  BtDTraps ~